function [matrices,centers,hyperplanes,empty]=ellipsoidfeasibility(A,b,v,D,x0)

n=length(x0);

V=pi^(n/2)/GAMMA(n/2+1)*det(D);
tstar=ceil(2*(n+1)*log(V/v));
matrices{1}=D;
centers{1}=x0;
hyperplanes{1}=[];

t=1;

while t<tstar,
    %det(D)
    x=centers{t};
    D=matrices{t};
    U=(A*x-b)>=0;
    U=U+1-1;
    if prod(U)==1,
        empty=0;
        break;
    else
        [toto,I]=sort(A*x-b,'ascend');
        i=I(1);
        a=A(i,:)';
        centers{t+1}=x+1/(n+1)*D*a/sqrt(a'*D*a);
        matrices{t+1}=n^2/(n^2-1)*(D-2/(n+1)* D*a*a'*D/(a'*D*a));
        hyperplanes{t}=[a;dot(a,x)];
    end
    t=t+1;
end
empty=1;
